diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/examples/wifi-manager-example.cc ns-3.45/src/wifi/examples/wifi-manager-example.cc
--- ns-3.44/src/wifi/examples/wifi-manager-example.cc	2025-03-09 16:55:49.775372500 -0700
+++ ns-3.45/src/wifi/examples/wifi-manager-example.cc	2025-06-01 20:34:45.608702200 -0700
@@ -248,7 +248,8 @@
     cmd.AddValue(
         "standard",
         "Set standard (802.11a, 802.11b, 802.11g, 802.11p-10MHz, 802.11p-5MHz, 802.11n-5GHz, "
-        "802.11n-2.4GHz, 802.11ac, 802.11ax-6GHz, 802.11ax-5GHz, 802.11ax-2.4GHz)",
+        "802.11n-2.4GHz, 802.11ac, 802.11ax-6GHz, 802.11ax-5GHz, 802.11ax-2.4GHz, 802.11be-6GHz, "
+        "802.11be-5GHz, 802.11be-2.4GHz)",
         standard);
     cmd.AddValue("wifiManager",
                  "Set wifi rate manager (Aarf, Aarfcd, Amrr, Arf, Cara, Ideal, Minstrel, "
@@ -334,7 +335,8 @@
             serverChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211ac, WIFI_PHY_BAND_5GHZ);
         }
         NS_ABORT_MSG_IF(serverChannelWidth != MHz_u{20} && serverChannelWidth != MHz_u{40} &&
-                            serverChannelWidth != MHz_u{80} && serverChannelWidth != MHz_u{160},
+                            serverChannelWidth != MHz_u{80} && serverChannelWidth != MHz_u{160} &&
+                            serverChannelWidth != MHz_u{320},
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(serverNss == 0 || serverNss > 4,
                         "Invalid nss " << serverNss << " for standard " << standard);
@@ -343,13 +345,15 @@
             clientChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211ac, WIFI_PHY_BAND_5GHZ);
         }
         NS_ABORT_MSG_IF(clientChannelWidth != MHz_u{20} && clientChannelWidth != MHz_u{40} &&
-                            clientChannelWidth != MHz_u{80} && clientChannelWidth != MHz_u{160},
+                            clientChannelWidth != MHz_u{80} && clientChannelWidth != MHz_u{160} &&
+                            clientChannelWidth != MHz_u{320},
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(clientNss == 0 || clientNss > 4,
                         "Invalid nss " << clientNss << " for standard " << standard);
     }
     else if (standard == "802.11ax-6GHz" || standard == "802.11ax-5GHz" ||
-             standard == "802.11ax-2.4GHz")
+             standard == "802.11ax-2.4GHz" || standard == "802.11be-6GHz" ||
+             standard == "802.11be-5GHz" || standard == "802.11be-2.4GHz")
     {
         WifiPhyBand band = (standard == "802.11ax-2.4GHz" ? WIFI_PHY_BAND_2_4GHZ
                             : standard == "802.11ax-6GHz" ? WIFI_PHY_BAND_6GHZ
@@ -359,7 +363,8 @@
             serverChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211ax, band);
         }
         NS_ABORT_MSG_IF(serverChannelWidth != MHz_u{20} && serverChannelWidth != MHz_u{40} &&
-                            serverChannelWidth != MHz_u{80} && serverChannelWidth != MHz_u{160},
+                            serverChannelWidth != MHz_u{80} && serverChannelWidth != MHz_u{160} &&
+                            serverChannelWidth != MHz_u{320},
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(serverNss == 0 || serverNss > 4,
                         "Invalid nss " << serverNss << " for standard " << standard);
@@ -368,7 +373,8 @@
             clientChannelWidth = GetDefaultChannelWidth(WIFI_STANDARD_80211ax, band);
         }
         NS_ABORT_MSG_IF(clientChannelWidth != MHz_u{20} && clientChannelWidth != MHz_u{40} &&
-                            clientChannelWidth != MHz_u{80} && clientChannelWidth != MHz_u{160},
+                            clientChannelWidth != MHz_u{80} && clientChannelWidth != MHz_u{160} &&
+                            clientChannelWidth != MHz_u{320},
                         "Invalid channel width for standard " << standard);
         NS_ABORT_MSG_IF(clientNss == 0 || clientNss > 4,
                         "Invalid nss " << clientNss << " for standard " << standard);
@@ -481,6 +487,33 @@
                      0,
                      60,
                      120 * channelRateFactor),
+        StandardInfo("802.11be-6GHz",
+                     WIFI_STANDARD_80211be,
+                     WIFI_PHY_BAND_6GHZ,
+                     serverChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     120 * channelRateFactor),
+        StandardInfo("802.11be-5GHz",
+                     WIFI_STANDARD_80211be,
+                     WIFI_PHY_BAND_5GHZ,
+                     serverChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     120 * channelRateFactor),
+        StandardInfo("802.11be-2.4GHz",
+                     WIFI_STANDARD_80211be,
+                     WIFI_PHY_BAND_2_4GHZ,
+                     serverChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     120 * channelRateFactor),
     };
 
     clientStandards = {
@@ -583,6 +616,33 @@
                      0,
                      60,
                      160 * channelRateFactor),
+        StandardInfo("802.11be-6GHz",
+                     WIFI_STANDARD_80211be,
+                     WIFI_PHY_BAND_6GHZ,
+                     clientChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     160 * channelRateFactor),
+        StandardInfo("802.11be-5GHz",
+                     WIFI_STANDARD_80211be,
+                     WIFI_PHY_BAND_5GHZ,
+                     clientChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     160 * channelRateFactor),
+        StandardInfo("802.11be-2.4GHz",
+                     WIFI_STANDARD_80211ax,
+                     WIFI_PHY_BAND_2_4GHZ,
+                     clientChannelWidth,
+                     5,
+                     55,
+                     0,
+                     60,
+                     160 * channelRateFactor),
     };
 
     for (std::vector<StandardInfo>::size_type i = 0; i != serverStandards.size(); i++)
@@ -780,7 +840,10 @@
     }
     else if (serverSelectedStandard.m_name == "802.11ax-6GHz" ||
              serverSelectedStandard.m_name == "802.11ax-5GHz" ||
-             serverSelectedStandard.m_name == "802.11ax-2.4GHz")
+             serverSelectedStandard.m_name == "802.11ax-2.4GHz" ||
+             serverSelectedStandard.m_name == "802.11be-6GHz" ||
+             serverSelectedStandard.m_name == "802.11be-5GHz" ||
+             serverSelectedStandard.m_name == "802.11be-2.4GHz")
     {
         wndServer->GetHeConfiguration()->SetGuardInterval(NanoSeconds(serverShortGuardInterval));
         wndClient->GetHeConfiguration()->SetGuardInterval(NanoSeconds(clientShortGuardInterval));
@@ -884,7 +947,9 @@
     title.append(wifiManager);
     title.append("\\n");
     if (standard == "802.11n-5GHz" || standard == "802.11n-2.4GHz" || standard == "802.11ac" ||
-        standard == "802.11ax-6GHz" || standard == "802.11ax-5GHz" || standard == "802.11ax-2.4GHz")
+        standard == "802.11ax-6GHz" || standard == "802.11ax-5GHz" ||
+        standard == "802.11ax-2.4GHz" || standard == "802.11be-6GHz" ||
+        standard == "802.11be-5GHz" || standard == "802.11be-2.4GHz")
     {
         std::ostringstream serverGiStrStr;
         std::ostringstream serverWidthStrStr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/helper/athstats-helper.h ns-3.45/src/wifi/helper/athstats-helper.h
--- ns-3.44/src/wifi/helper/athstats-helper.h	2025-03-09 16:55:49.779372700 -0700
+++ ns-3.45/src/wifi/helper/athstats-helper.h	2025-06-01 20:34:45.608702200 -0700
@@ -232,8 +232,7 @@
     std::ofstream* m_writer; ///< output stream
 
     Time m_interval; ///< interval
-
-}; // class AthstatsWifiTraceSink
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/helper/wifi-helper.cc ns-3.45/src/wifi/helper/wifi-helper.cc
--- ns-3.44/src/wifi/helper/wifi-helper.cc	2025-03-09 16:55:49.779372700 -0700
+++ ns-3.45/src/wifi/helper/wifi-helper.cc	2025-06-01 20:34:45.609702000 -0700
@@ -34,6 +34,9 @@
 #include <bit>
 #include <memory>
 
+namespace ns3
+{
+
 namespace
 {
 /**
@@ -49,10 +52,17 @@
     const auto shift = std::countr_zero(mask);
     return (val << shift) & mask;
 }
-} // namespace
 
-namespace ns3
-{
+/// 320 MHz channelization map
+const std::map<MHz_u, RadiotapHeader::UsigCommonBw> channelization320MHzMap{
+    {MHz_u{6105}, RadiotapHeader::USIG_COMMON_BW_320MHZ_1},
+    {MHz_u{6425}, RadiotapHeader::USIG_COMMON_BW_320MHZ_1},
+    {MHz_u{6745}, RadiotapHeader::USIG_COMMON_BW_320MHZ_1},
+    {MHz_u{6265}, RadiotapHeader::USIG_COMMON_BW_320MHZ_2},
+    {MHz_u{6585}, RadiotapHeader::USIG_COMMON_BW_320MHZ_2},
+    {MHz_u{6905}, RadiotapHeader::USIG_COMMON_BW_320MHZ_2},
+};
+} // namespace
 
 NS_LOG_COMPONENT_DEFINE("WifiHelper");
 
@@ -522,13 +532,13 @@
         heFields.data2 = RadiotapHeader::HE_DATA2_GI_KNOWN;
         if (preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB)
         {
+            NS_ASSERT(WifiRu::IsHe(txVector.GetHeMuUserInfo(staId).ru));
+            auto heRu = std::get<HeRu::RuSpec>(txVector.GetHeMuUserInfo(staId).ru);
             heFields.data2 |=
                 RadiotapHeader::HE_DATA2_RU_OFFSET_KNOWN |
                 // HeRu indices start at 1 whereas RadioTap starts at 0
-                GetRadiotapField(RadiotapHeader::HE_DATA2_RU_OFFSET,
-                                 txVector.GetHeMuUserInfo(staId).ru.GetIndex() - 1) |
-                GetRadiotapField(RadiotapHeader::HE_DATA2_PRISEC_80_SEC,
-                                 !txVector.GetHeMuUserInfo(staId).ru.GetPrimary80MHz());
+                GetRadiotapField(RadiotapHeader::HE_DATA2_RU_OFFSET, heRu.GetIndex() - 1) |
+                GetRadiotapField(RadiotapHeader::HE_DATA2_PRISEC_80_SEC, !heRu.GetPrimary80MHz());
         }
 
         heFields.data3 =
@@ -542,28 +552,28 @@
         heFields.data5 = 0;
         if (preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB)
         {
-            HeRu::RuType ruType = txVector.GetHeMuUserInfo(staId).ru.GetRuType();
+            const auto ruType = WifiRu::GetRuType(txVector.GetHeMuUserInfo(staId).ru);
             switch (ruType)
             {
-            case HeRu::RU_26_TONE:
+            case RuType::RU_26_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_26T;
                 break;
-            case HeRu::RU_52_TONE:
+            case RuType::RU_52_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_52T;
                 break;
-            case HeRu::RU_106_TONE:
+            case RuType::RU_106_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_106T;
                 break;
-            case HeRu::RU_242_TONE:
+            case RuType::RU_242_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_242T;
                 break;
-            case HeRu::RU_484_TONE:
+            case RuType::RU_484_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_484T;
                 break;
-            case HeRu::RU_996_TONE:
+            case RuType::RU_996_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_996T;
                 break;
-            case HeRu::RU_2x996_TONE:
+            case RuType::RU_2x996_TONE:
                 heFields.data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_2x996T;
                 break;
             default:
@@ -628,6 +638,10 @@
             usigFields.common |= GetRadiotapField(RadiotapHeader::USIG_COMMON_BW,
                                                   RadiotapHeader::USIG_COMMON_BW_160MHZ);
             break;
+        case 320:
+            usigFields.common |= GetRadiotapField(RadiotapHeader::USIG_COMMON_BW,
+                                                  channelization320MHzMap.at(channelFreqMhz));
+            break;
         default:
             NS_ABORT_MSG("Unexpected channel width");
             break;
@@ -646,9 +660,8 @@
             std::optional<bool> isLow80MHz;
             if (txVector.IsDlMu() && channelWidth > MHz_u{80})
             {
-                const auto isLowP80 = p20Index < (channelWidth / MHz_u{40});
-                const auto isP80 = txVector.GetHeMuUserInfo(staId).ru.GetPrimary80MHz();
-                isLow80MHz = (isLowP80 && isP80) || (!isLowP80 && !isP80);
+                isLow80MHz = true;
+                // TODO: fix once EHT RUs are used
             }
             const auto puncturedChannelInfo =
                 EhtPpdu::GetPuncturedInfo(txVector.GetInactiveSubchannels(),
@@ -690,44 +703,49 @@
             break;
         }
         ehtFields.data.at(1) = RadiotapHeader::EHT_DATA1_RU_ALLOC_CC_1_1_1_KNOWN;
-        const auto ruType = (txVector.GetEhtPpduType() == 1) ? HeRu::GetRuType(channelWidth)
-                                                             : txVector.GetRu(staId).GetRuType();
+        const auto ruType = (txVector.GetEhtPpduType() == 1)
+                                ? WifiRu::GetRuType(channelWidth)
+                                : WifiRu::GetRuType(txVector.GetRu(staId));
         switch (ruType)
         {
-        case HeRu::RU_26_TONE:
+        case RuType::RU_26_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_26);
             break;
-        case HeRu::RU_52_TONE:
+        case RuType::RU_52_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_52);
             break;
-        case HeRu::RU_106_TONE:
+        case RuType::RU_106_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_106);
             break;
-        case HeRu::RU_242_TONE:
+        case RuType::RU_242_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_242);
             break;
-        case HeRu::RU_484_TONE:
+        case RuType::RU_484_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_484);
             break;
-        case HeRu::RU_996_TONE:
+        case RuType::RU_996_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_996);
             break;
-        case HeRu::RU_2x996_TONE:
+        case RuType::RU_2x996_TONE:
             ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
                                                      RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_2x996);
             break;
+        case RuType::RU_4x996_TONE:
+            ehtFields.data.at(1) |= GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_SIZE,
+                                                     RadiotapHeader::EHT_DATA1_RU_MRU_SIZE_4x996);
+            break;
         default:
             NS_ABORT_MSG("Unexpected RU type");
             break;
         }
         const auto ruIndex =
-            (txVector.GetEhtPpduType() == 1) ? 1 : txVector.GetRu(staId).GetIndex();
+            (txVector.GetEhtPpduType() == 1) ? 1 : WifiRu::GetIndex(txVector.GetRu(staId));
         const auto& ruAllocation = txVector.GetRuAllocation(p20Index);
         ehtFields.data.at(1) |=
             GetRadiotapField(RadiotapHeader::EHT_DATA1_RU_MRU_INDEX, ruIndex) |
@@ -765,7 +783,28 @@
                                  (isLowP80 ? RadiotapHeader::EHT_DATA1_PRIMARY_80_LOWEST
                                            : RadiotapHeader::EHT_DATA1_PRIMARY_80_HIGHEST));
         }
-        // TODO: handle 320 MHz when supported
+        if (channelWidth >= MHz_u{320})
+        {
+            ehtFields.data.at(4) |=
+                RadiotapHeader::EHT_DATA4_RU_ALLOC_CC_1_2_3_KNOWN |
+                RadiotapHeader::EHT_DATA4_RU_ALLOC_CC_2_2_3_KNOWN |
+                GetRadiotapField(RadiotapHeader::EHT_DATA4_RU_ALLOC_CC_1_2_3, ruAllocation.at(8)) |
+                GetRadiotapField(RadiotapHeader::EHT_DATA4_RU_ALLOC_CC_2_2_3, ruAllocation.at(9));
+            ehtFields.data.at(5) =
+                RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_1_2_4_KNOWN |
+                RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_2_2_4_KNOWN |
+                RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_1_2_5_KNOWN |
+                GetRadiotapField(RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_1_2_4, ruAllocation.at(10)) |
+                GetRadiotapField(RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_2_2_4, ruAllocation.at(11)) |
+                GetRadiotapField(RadiotapHeader::EHT_DATA5_RU_ALLOC_CC_1_2_5, ruAllocation.at(12));
+            ehtFields.data.at(6) =
+                RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_2_2_5_KNOWN |
+                RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_1_2_6_KNOWN |
+                RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_2_2_6_KNOWN |
+                GetRadiotapField(RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_2_2_5, ruAllocation.at(13)) |
+                GetRadiotapField(RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_1_2_6, ruAllocation.at(14)) |
+                GetRadiotapField(RadiotapHeader::EHT_DATA6_RU_ALLOC_CC_2_2_6, ruAllocation.at(15));
+        }
         uint32_t userInfo = RadiotapHeader::EHT_USER_INFO_STA_ID_KNOWN |
                             RadiotapHeader::EHT_USER_INFO_MCS_KNOWN |
                             RadiotapHeader::EHT_USER_INFO_NSS_KNOWN_O |
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/helper/wifi-mac-helper.cc ns-3.45/src/wifi/helper/wifi-mac-helper.cc
--- ns-3.44/src/wifi/helper/wifi-mac-helper.cc	2025-03-09 16:55:49.779372700 -0700
+++ ns-3.45/src/wifi/helper/wifi-mac-helper.cc	2025-06-01 20:34:45.609702000 -0700
@@ -149,21 +149,19 @@
         staMac->SetAssocManager(assocManager);
     }
 
-    // create and install the EMLSR Manager if this is an EHT non-AP MLD with EMLSR activated
-    if (BooleanValue emlsrActivated;
-        standard >= WIFI_STANDARD_80211be && staMac && staMac->GetNLinks() > 1 &&
-        device->GetEhtConfiguration()->GetAttributeFailSafe("EmlsrActivated", emlsrActivated) &&
-        emlsrActivated.Get())
+    // create and install the EMLSR Manager if this is an EHT non-AP device with EMLSR activated
+    // and association type set to ML setup
+    if (standard >= WIFI_STANDARD_80211be && staMac &&
+        device->GetEhtConfiguration()->m_emlsrActivated &&
+        staMac->GetAssocType() == WifiAssocType::ML_SETUP)
     {
         auto emlsrManager = m_emlsrManager.Create<EmlsrManager>();
         staMac->SetEmlsrManager(emlsrManager);
     }
 
     // create and install the AP EMLSR Manager if this is an EHT AP MLD with EMLSR activated
-    if (BooleanValue emlsrActivated;
-        standard >= WIFI_STANDARD_80211be && apMac && apMac->GetNLinks() > 1 &&
-        device->GetEhtConfiguration()->GetAttributeFailSafe("EmlsrActivated", emlsrActivated) &&
-        emlsrActivated.Get())
+    if (standard >= WIFI_STANDARD_80211be && apMac && apMac->GetNLinks() > 1 &&
+        device->GetEhtConfiguration()->m_emlsrActivated)
     {
         auto apEmlsrManager = m_apEmlsrManager.Create<ApEmlsrManager>();
         apMac->SetApEmlsrManager(apEmlsrManager);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/helper/wifi-phy-rx-trace-helper.h ns-3.45/src/wifi/helper/wifi-phy-rx-trace-helper.h
--- ns-3.44/src/wifi/helper/wifi-phy-rx-trace-helper.h	2025-03-09 16:55:49.779372700 -0700
+++ ns-3.45/src/wifi/helper/wifi-phy-rx-trace-helper.h	2025-06-01 20:34:45.609702000 -0700
@@ -669,8 +669,7 @@
      */
     void CountStatisticsForRecord(WifiPhyTraceStatistics& statistics,
                                   const WifiPpduRxRecord& record) const;
-
-}; // class WifiPhyRxTraceSink
+};
 
 // Non-member function declarations
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/addba-extension.cc ns-3.45/src/wifi/model/addba-extension.cc
--- ns-3.44/src/wifi/model/addba-extension.cc	2025-03-09 16:55:49.779372700 -0700
+++ ns-3.45/src/wifi/model/addba-extension.cc	2025-06-01 20:34:45.609702000 -0700
@@ -14,7 +14,9 @@
 void
 AddbaExtension::Print(std::ostream& os) const
 {
-    os << "extBufferSize=" << +m_extParamSet.extBufferSize;
+    os << "ADDBA Extension=[No Fragmentation: " << +m_extParamSet.noFragment
+       << ", HE Fragmentation Operation: " << +m_extParamSet.heFragmentOp
+       << ", Extended Buffer Size: " << +m_extParamSet.extBufferSize << "]";
 }
 
 WifiInformationElementId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ap-wifi-mac.cc ns-3.45/src/wifi/model/ap-wifi-mac.cc
--- ns-3.44/src/wifi/model/ap-wifi-mac.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/ap-wifi-mac.cc	2025-06-01 20:34:45.611702200 -0700
@@ -209,7 +209,8 @@
 }
 
 ApWifiMac::ApWifiMac()
-    : m_enableBeaconGeneration(false)
+    : m_enableBeaconGeneration(false),
+      m_grpAddrBuIndicExp(0)
 {
     NS_LOG_FUNCTION(this);
     m_beaconTxop = CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BEACON"));
@@ -342,6 +343,14 @@
     {
         GetLink(linkId).channelAccessManager->Add(m_beaconTxop);
     }
+
+    // the value 'exp' for the Group Addressed BU Indication Exponent must be such that 2^(exp+1)-1
+    // is at least equal to N-1, where N is the number of links (Sec. 35.3.15.1 of 802.11be D7.0).
+    // The max value for Group Addressed BU Indication Exponent is 3 (encoded in a 2-bit subfield)
+    while ((m_grpAddrBuIndicExp < 3) && ((1 << (m_grpAddrBuIndicExp + 1)) - 1 < GetNLinks() - 1))
+    {
+        ++m_grpAddrBuIndicExp;
+    }
 }
 
 Ptr<WifiMacQueue>
@@ -1139,8 +1148,9 @@
     NS_ASSERT(GetEhtSupported());
     EhtOperation operation;
     auto remoteStationManager = GetWifiRemoteStationManager(linkId);
+    const auto phy = GetWifiPhy(linkId);
 
-    auto maxSpatialStream = GetWifiPhy(linkId)->GetMaxSupportedRxSpatialStreams();
+    auto maxSpatialStream = phy->GetMaxSupportedRxSpatialStreams();
     for (const auto& sta : GetLink(linkId).staList)
     {
         if (remoteStationManager->GetEhtSupported(sta.second))
@@ -1153,6 +1163,14 @@
     }
     operation.SetMaxRxNss(maxSpatialStream, 0, WIFI_EHT_MAX_MCS_INDEX);
     operation.SetMaxTxNss(maxSpatialStream, 0, WIFI_EHT_MAX_MCS_INDEX);
+    operation.m_params.grpBuExp = m_grpAddrBuIndicExp;
+
+    if (const auto bw = phy->GetChannelWidth();
+        (phy->GetPhyBand() == WIFI_PHY_BAND_6GHZ) && (bw == MHz_u{320}))
+    {
+        operation.m_opInfo.emplace(EhtOperation::EhtOpInfo{{.channelWidth = 4}});
+        operation.m_params.opInfoPresent = 1;
+    }
     return operation;
 }
 
@@ -2672,8 +2690,13 @@
 {
     const auto& links = GetLinks();
 
-    // Return the first AID value between 1 and 2007 that is free for all the links
-    for (uint16_t nextAid = 1; nextAid <= 2007; ++nextAid)
+    // if this is an AP MLD, AIDs from 1 to N, where N is 2^(Group_addr_BU_Indic_Exp + 1) - 1
+    // shall not be allocated (see Section 35.3.15.1 of 802.11be D7.0)
+    const uint16_t startAid = links.size() == 1 ? MIN_AID : (1 << (m_grpAddrBuIndicExp + 1));
+
+    // Return the first AID value between min and max that is free for all the links
+    const auto maxAid = GetEhtSupported() ? EHT_MAX_AID : MAX_AID;
+    for (uint16_t nextAid = startAid; nextAid <= maxAid; ++nextAid)
     {
         if (std::none_of(links.cbegin(), links.cend(), [&](auto&& idLinkPair) {
                 return GetStaList(idLinkPair.first).contains(nextAid);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ap-wifi-mac.h ns-3.45/src/wifi/model/ap-wifi-mac.h
--- ns-3.44/src/wifi/model/ap-wifi-mac.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/ap-wifi-mac.h	2025-06-01 20:34:45.611702200 -0700
@@ -123,6 +123,9 @@
      */
     uint16_t GetAssociationId(Mac48Address addr, uint8_t linkId) const;
 
+    /// @return the next Association ID to be allocated by the AP
+    uint16_t GetNextAssociationId() const;
+
     /**
      * Get the ID of a link (if any) that has been setup with the station having the given MAC
      * address. The address can be either a link address or an MLD address. In the former case,
@@ -623,11 +626,6 @@
     void DoDispose() override;
     void DoInitialize() override;
 
-    /**
-     * @return the next Association ID to be allocated by the AP
-     */
-    uint16_t GetNextAssociationId() const;
-
     Ptr<Txop> m_beaconTxop;        //!< Dedicated Txop for beacons
     bool m_enableBeaconGeneration; //!< Flag whether beacons are being generated
     Time m_beaconInterval;         //!< Beacon interval
@@ -639,6 +637,7 @@
     Time m_bsrLifetime;            //!< Lifetime of Buffer Status Reports
     /// transition timeout events running for EMLSR clients
     std::map<Mac48Address, EventId> m_transitionTimeoutEvents;
+    uint8_t m_grpAddrBuIndicExp; //!< Group Addressed BU Indication Exponent of EHT Operation IE
     Ptr<ApEmlsrManager> m_apEmlsrManager; ///< AP EMLSR Manager
     Ptr<GcrManager> m_gcrManager;         //!< GCR Manager
 
